#
#   5B - Text object
#

from pygame import Rect
from albow.controls import TextField
from albow.dialogs import Dialog
from albow.resource import get_font
from part import Part
from vector_algebra import Origin2

text_font = get_font(18, "VeraBd.ttf")
text_color = (255, 255, 0)

class Text(Part):
	#  text   string
	
	terminal_points = []
	
	text = ""

	def draw(self, surf, t):
		text = self.get_text_for_display()
		buf = text_font.render(text, True, text_color)
		r = self.get_translated_global_rect(t)
		surf.blit(buf, r)
	
	def get_translated_global_rect(self, t):
		p = t * self.position
		text = self.get_text_for_display()
		r = Rect((0, 0), text_font.size(text))
		r.midleft = p.coords
		return r

	def get_text_for_display(self):
		return self.text or "[TEXT]"

	def read_params(self, r):
		self.text = r.get_arg(str)
	
	def get_params(self, params):
		params.append(self.text)

	def edit_params(self):
		field = TextField(500)
		field.rect.topleft = (10, 10)
		field.set_text(self.text)
		dlog = Dialog()
		dlog.border_width = 1
		dlog.add(field)
		dlog.shrink_wrap()
		field.focus()
		if dlog.present():
			self.text = field.get_text()
