#
#   555-BOOM! - Game-wide settings and command line options
#

import os, sys
from optparse import OptionParser

screen_size = (800, 600)
flags = 0
frame_time = 40

# The following paths are relative to the directory containing
# the run_game.py file.
default_save_dir_name = "Saves"
default_std_level_dir_name = "Resources/levels"
default_custom_level_dir_name = "Mods"

#usage = "%prog [options] [saved_game | level_file]"
usage = "%prog [options] [level_file]"

options = None

def get_command_line_options():
	global options
	parser = OptionParser(usage = usage)
	def opt(long, dest, help, short = None, type = None):
		if type:
			action = 'store'
		else:
			action = 'store_true'
		parser.add_option(short, long, action = action, dest = dest, help = help,
			type = type)
	opt("--edit", 'edit', "Start in edit mode", "-e")
	opt("--edit-std", 'edit_std_levels', "Enable editing standard levels", "-E")
	options, args = parser.parse_args()
	if args:
		options.filename = args[0]
	else:
		options.filename = None

def get_default_save_dir():
	parent = os.path.dirname(sys.path[0])
	return os.path.join(parent, default_save_dir_name)

def get_default_editor_level_dir():
	parent = os.path.dirname(sys.path[0])
	return os.path.join(parent, default_custom_level_dir_name)

def get_default_playing_level_dir():
	parent = os.path.dirname(sys.path[0])
	return os.path.join(parent, default_std_level_dir_name)

def milliseconds_to_frames(ms):
	return ms // frame_time

def seconds_to_frames(sec):
	return sec * 1000 // frame_time

def frames_to_seconds(frm):
	return frm * frame_time // 1000
